# Regular Expressions

Collaboration diagram for Regular Expressions:

## Classes

- class std::basic_regex< _Ch_type, _Rx_traits >
- class std::match_results< _Bi_iter, _Allocator >
    The results of a match or search operation. More...
- class std::regex_error
    A regular expression exception class.

    The regular expression library throws objects of this class on error. More...

- class std::regex_iterator< _Bi_iter, _Ch_type, _Rx_traits >
- class std::regex_token_iterator< _Bi_iter, _Ch_type, _Rx_traits >
- struct std::regex_traits< _Ch_type >
    Describes aspects of a regular expression. More...
- class std::sub_match< _BiIter >

## Namespaces

- namespace std::regex_constants

## Typedefs

- typedef match_results< const
  char * > std::cmatch
- typedef regex_iterator< const
  char * > std::cregex_iterator
- typedef regex_token_iterator
  < const char * > std::cregex_token_iterator
- typedef sub_match< const char * > std::csub_match
- typedef basic_regex< char > std::regex
- typedef match_results
  < string::const_iterator > std::smatch
- typedef regex_iterator
  < string::const_iterator > std::sregex_iterator
- typedef regex_token_iterator
  < string::const_iterator > std::sregex_token_iterator
- typedef sub_match
  < string::const_iterator > std::ssub_match
- typedef match_results< const
  wchar_t * > std::wcmatch
- typedef regex_iterator< const
  wchar_t * > std::wcregex_iterator
- typedef regex_token_iterator
  < const wchar_t * > std::wcregex_token_iterator
- typedef sub_match< const
  wchar_t * > std::wcsub_match
- typedef basic_regex< wchar_t > std::wregex
- typedef match_results
  < wstring::const_iterator > std::wsmatch
- typedef regex_iterator
  < wstring::const_iterator > std::wsregex_iterator
- typedef regex_token_iterator
  < wstring::const_iterator > std::wsregex_token_iterator
- typedef sub_match
  < wstring::const_iterator > std::wssub_match

## Functions

- bool std::regex_traits::isctype (_Ch_type __c, char_class_type __f) const
- template<typename _Bi_iter , class _Allocator > bool std::operator!= (const match_results< _Bi_iter, _Allocator > &__m1, const match_results< _Bi_iter, _Allocator > &__m2)
- template<typename _Bi_iter > bool std::operator!= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
- template<typename _Bi_iter > bool std::operator!= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter > bool std::operator!= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
- template<typename _Bi_iter > bool std::operator!= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator!= (const sub_match< _Bi_iter > &__lhs, const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator!= (const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _BiIter > bool std::operator!= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
- template<typename _Bi_iter > bool std::operator< (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
- template<typename _Bi_iter > bool std::operator< (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter > bool std::operator< (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
- template<typename _Bi_iter > bool std::operator< (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc > bool std::operator< (const sub_match< _Bi_iter > &__lhs, const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator< (const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _BiIter > bool std::operator< (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
- template<typename _Ch_type , typename _Ch_traits , typename _Bi_iter > basic_ostream< _Ch_type,
  _Ch_traits > & std::operator<< (basic_ostream< _Ch_type, _Ch_traits > &__os, const sub_match< _Bi_iter > &__m)
- template<typename _Bi_iter > bool std::operator<= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
- template<typename _Bi_iter > bool std::operator<= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter > bool std::operator<= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
- template<typename _Bi_iter > bool std::operator<= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc > bool std::operator<= (const sub_match< _Bi_iter > &__lhs, const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator<= (const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _BiIter > bool std::operator<= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
- template<typename _Bi_iter , typename _Allocator > bool std::operator== (const match_results< _Bi_iter, _Allocator > &__m1, const match_results< _Bi_iter, _Allocator > &__m2)
- template<typename _Bi_iter > bool std::operator== (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
- template<typename _Bi_iter > bool std::operator== (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter > bool std::operator== (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
- template<typename _Bi_iter > bool std::operator== (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator== (const sub_match< _Bi_iter > &__lhs, const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator== (const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _BiIter > bool std::operator== (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
- template<typename _Bi_iter > bool std::operator> (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
- template<typename _Bi_iter > bool std::operator> (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter > bool std::operator> (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
- template<typename _Bi_iter > bool std::operator> (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc > bool std::operator> (const sub_match< _Bi_iter > &__lhs, const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator> (const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _BiIter > bool std::operator> (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
- template<typename _Bi_iter > bool std::operator>= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const &__rhs)
- template<typename _Bi_iter > bool std::operator>= (typename iterator_traits< _Bi_iter >::value_type const &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter > bool std::operator>= (const sub_match< _Bi_iter > &__lhs, typename iterator_traits< _Bi_iter >::value_type const *__rhs)
- template<typename _Bi_iter > bool std::operator>= (typename iterator_traits< _Bi_iter >::value_type const *__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc > bool std::operator>= (const sub_match< _Bi_iter > &__lhs, const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__rhs)
- template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc > bool std::operator>= (const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > &__lhs, const sub_match< _Bi_iter > &__rhs)
- template<typename _BiIter > bool std::operator>= (const sub_match< _BiIter > &__lhs, const sub_match< _BiIter > &__rhs)
- template<typename _Bi_iter , typename _Allocator > void std::swap (match_results< _Bi_iter, _Allocator > &__lhs, match_results< _Bi_iter, _Allocator > &__rhs)
- template<typename _Ch_type , typename _Rx_traits > void std::swap (basic_regex< _Ch_type, _Rx_traits > &__lhs, basic_regex< _Ch_type, _Rx_traits > &__rhs)
- int std::regex_traits::value (_Ch_type __ch, int __radix) const

## Matching, Searching, and Replacing

- template<typename _Ch_traits , typename _Str_allocator , typename _Ch_type , typename _Rx_traits > bool std::regex_match (const basic_string< _Ch_type, _Ch_traits, _Str_allocator > &__s, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Ch_type , class _Rx_traits > bool std::regex_match (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __f=regex_constants::match_default)
- template<typename _Ch_traits , typename _Ch_alloc , typename _Allocator , typename _Ch_type , typename _Rx_traits > bool std::regex_match (const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > &__s, match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Allocator > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Ch_type , typename _Allocator , typename _Rx_traits > bool std::regex_match (const _Ch_type *__s, match_results< const _Ch_type *, _Allocator > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __f=regex_constants::match_default)
- template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits > bool std::regex_match (_Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Bi_iter , typename _Allocator , typename _Ch_type , typename _Rx_traits > bool std::regex_match (_Bi_iter __first, _Bi_iter __last, match_results< _Bi_iter, _Allocator > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Rx_traits , typename _Ch_type > basic_string< _Ch_type > std::regex_replace (const basic_string< _Ch_type > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type > _Out_iter std::regex_replace (_Out_iter __out, _Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__e, const basic_string< _Ch_type > &__fmt, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Ch_traits , typename _Ch_alloc , typename _Allocator , typename _Ch_type , typename _Rx_traits > bool std::regex_search (const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > &__s, match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Allocator > &__m, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
- template<typename _Ch_traits , typename _String_allocator , typename _Ch_type , typename _Rx_traits > bool std::regex_search (const basic_string< _Ch_type, _Ch_traits, _String_allocator > &__s, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Ch_type , typename _Rx_traits > bool std::regex_search (const _Ch_type *__s, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
- template<typename _Ch_type , class _Allocator , class _Rx_traits > bool std::regex_search (const _Ch_type *__s, match_results< const _Ch_type *, _Allocator > &__m, const basic_regex< _Ch_type, _Rx_traits > &__e, regex_constants::match_flag_type __f=regex_constants::match_default)
- template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits > bool std::regex_search (_Bi_iter __first, _Bi_iter __last, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)
- template<typename _Bi_iter , typename _Allocator , typename _Ch_type , typename _Rx_traits > bool std::regex_search (_Bi_iter __first, _Bi_iter __last, match_results< _Bi_iter, _Allocator > &__m, const basic_regex< _Ch_type, _Rx_traits > &__re, regex_constants::match_flag_type __flags=regex_constants::match_default)

## Detailed Description

A facility for performing regular expression pattern matching.

## Typedef Documentation

typedef regex_token_iterator<const char*> std::cregex_token_iterator

Token iterator for C-style NULL-terminated strings.

Definition at line 2695 of file tr1_impl/regex.

typedef sub_match<const char*> std::csub_match

Standard regex submatch over a C-style null-terminated string.

Definition at line 1176 of file tr1_impl/regex.

typedef basic_regex<char> std::regex

Standard regular expressions.

Definition at line 1052 of file tr1_impl/regex.

typedef regex_token_iterator<string::const_iterator> std::sregex_token_iterator

Token iterator for standard strings.

Definition at line 2697 of file tr1_impl/regex.

typedef sub_match<string::const_iterator> std::ssub_match

Standard regex submatch over a standard string.

Definition at line 1178 of file tr1_impl/regex.

typedef regex_token_iterator<const wchar_t*> std::wcregex_token_iterator

Token iterator for C-style NULL-terminated wide strings.

Definition at line 2700 of file tr1_impl/regex.

typedef sub_match<const wchar_t*> std::wcsub_match

Regex submatch over a C-style null-terminated wide string.

Definition at line 1181 of file tr1_impl/regex.

typedef basic_regex<wchar_t> std::wregex

Standard wide-character regular expressions.

Definition at line 1055 of file tr1_impl/regex.

typedef regex_token_iterator<wstring::const_iterator> std::wsregex_token_iterator

Token iterator for standard wide-character strings.

Definition at line 2702 of file tr1_impl/regex.

typedef sub_match<wstring::const_iterator> std::wssub_match

Regex submatch over a standard wide string.

Definition at line 1183 of file tr1_impl/regex.

## Function Documentation

template<typename _Ch_type >

bool std::regex_traits< _Ch_type >::isctype | ( | _Ch_type | __c,
|  | char_class_type | __f |
| ) |  |  | const`[inline, inherited]`

Determines if `c` is a member of an identified class.

Parameters:

  | c | a character.
  | f | a class type (as returned from lookup_classname).

Returns:
  true if the character `c` is a member of the classification represented by `f`, false otherwise.

Exceptions:

  | std::bad_cast | if the current locale does not have a ctype facet.

Definition at line 653 of file tr1_impl/regex.

References std::__ctype_abstract_base< _CharT >::is(), std::regex_traits< _Ch_type >::lookup_classname(), std::use_facet(), and std::__ctype_abstract_base< _CharT >::widen().

template<typename _Bi_iter , class _Allocator >

bool std::operator!= | ( | const match_results< _Bi_iter, _Allocator > & | __m1,
|  | const match_results< _Bi_iter, _Allocator > & | __m2 |
| ) |  |  | `[inline]`

Compares two match_results for inequality.

Returns:
  true if the two objects do not refer to the same match, false otherwise.

Definition at line 2070 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A const string reference.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1671 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator!= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1597 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A pointer to a string.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1523 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator!= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of an iterator value and a regular expression submatch.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1449 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator!= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1365 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator!= | ( | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1284 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator!= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs |
| ) |  |  | `[inline]`

Tests the inequivalence of two regular expression submatches.

Parameters:

  | lhs | First regular expression submatch.
  | rhs | Second regular expression submatch.

Returns:
  true if lhs is not equivalent to rhs, false otherwise.

Definition at line 1208 of file tr1_impl/regex.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A const string reference.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1683 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator< | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1609 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1535 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator< | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1461 of file tr1_impl/regex.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator< | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1379 of file tr1_impl/regex.

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator< | ( | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1297 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator< | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of two regular expression submatches.

Parameters:

  | lhs | First regular expression submatch.
  | rhs | Second regular expression submatch.

Returns:
  true if lhs precedes rhs, false otherwise.

Definition at line 1220 of file tr1_impl/regex.

template<typename _Ch_type , typename _Ch_traits , typename _Bi_iter >

basic_ostream<_Ch_type, _Ch_traits>& std::operator<< | ( | basic_ostream< _Ch_type, _Ch_traits > & | __os,
|  | const sub_match< _Bi_iter > & | __m |
| ) |  |  | `[inline]`

Inserts a matched string into an output stream.

Parameters:

  | os | The output stream.
  | m | A submatch string.

Returns:
  the output stream with the submatch string inserted.

Definition at line 1734 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A const string reference.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1719 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator<= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1645 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1571 of file tr1_impl/regex.

template<typename _Bi_iter >

bool std::operator<= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1497 of file tr1_impl/regex.

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator<= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1421 of file tr1_impl/regex.

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator<= | ( | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1336 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator<= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of two regular expression submatches.

Parameters:

  | lhs | First regular expression submatch.
  | rhs | Second regular expression submatch.

Returns:
  true if lhs does not succeed rhs, false otherwise.

Definition at line 1232 of file tr1_impl/regex.

template<typename _Bi_iter , typename _Allocator >

bool std::operator== | ( | const match_results< _Bi_iter, _Allocator > & | __m1,
|  | const match_results< _Bi_iter, _Allocator > & | __m2 |
| ) |  |  | `[inline]`

Compares two match_results for equality.

Returns:
  true if the two objects refer to the same match, false otherwise.

Todo:
  Implement this function.

template<typename _Bi_iter >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A const string reference.

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1658 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator== | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1584 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A pointer to a string?

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1510 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator== | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of a C string and a regular expression submatch.

Parameters:

  | lhs | A C string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1436 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator== | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1350 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator== | ( | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1269 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator== | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs |
| ) |  |  | `[inline]`

Tests the equivalence of two regular expression submatches.

Parameters:

  | lhs | First regular expression submatch.
  | rhs | Second regular expression submatch.

Returns:
  true if lhs is equivalent to rhs, false otherwise.

Definition at line 1196 of file tr1_impl/regex.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A const string reference.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1695 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator> | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1621 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1547 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator> | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1473 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator> | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1393 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator> | ( | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1310 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator> | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of two regular expression submatches.

Parameters:

  | lhs | First regular expression submatch.
  | rhs | Second regular expression submatch.

Returns:
  true if lhs succeeds rhs, false otherwise.

Definition at line 1256 of file tr1_impl/regex.

References std::sub_match< _BiIter >::compare().

template<typename _Bi_iter >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A const string reference.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1707 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator>= | ( | typename iterator_traits< _Bi_iter >::value_type const & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1633 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | typename iterator_traits< _Bi_iter >::value_type const * | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1559 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter >

bool std::operator>= | ( | typename iterator_traits< _Bi_iter >::value_type const * | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1485 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , class _Ch_traits , class _Ch_alloc >

bool std::operator>= | ( | const sub_match< _Bi_iter > & | __lhs,
|  | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a regular expression submatch and a string.

Parameters:

  | lhs | A regular expression submatch.
  | rhs | A string.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1407 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _Bi_iter , typename _Ch_traits , typename _Ch_alloc >

bool std::operator>= | ( | const basic_string< typename iterator_traits< _Bi_iter >::value_type, _Ch_traits, _Ch_alloc > & | __lhs,
|  | const sub_match< _Bi_iter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of a string and a regular expression submatch.

Parameters:

  | lhs | A string.
  | rhs | A regular expression submatch.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1323 of file tr1_impl/regex.

References std::sub_match< _BiIter >::str().

template<typename _BiIter >

bool std::operator>= | ( | const sub_match< _BiIter > & | __lhs,
|  | const sub_match< _BiIter > & | __rhs |
| ) |  |  | `[inline]`

Tests the ordering of two regular expression submatches.

Parameters:

  | lhs | First regular expression submatch.
  | rhs | Second regular expression submatch.

Returns:
  true if lhs does not precede rhs, false otherwise.

Definition at line 1244 of file tr1_impl/regex.

References std::sub_match< _BiIter >::compare().

template<typename _Ch_traits , typename _Str_allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | const basic_string< _Ch_type, _Ch_traits, _Str_allocator > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Indicates if there is a match between the regular expression `e` and a string.

Parameters:

  | s | [IN] The string to match.
  | re | [IN] The regular expression.
  | flags | [IN] Controls how the regular expression is matched.

Return values:

  | true | A match exists.
  | false | Otherwise.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2230 of file tr1_impl/regex.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_match().

template<typename _Ch_type , class _Rx_traits >

bool std::regex_match | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Indicates if there is a match between the regular expression `e` and a C-style null-terminated string.

Parameters:

  | s | The C-style null-terminated string to match.
  | re | The regular expression.
  | f | Controls how the regular expression is matched.

Return values:

  | true | A match exists.
  | false | Otherwise.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2208 of file tr1_impl/regex.

References std::regex_match().

template<typename _Ch_traits , typename _Ch_alloc , typename _Allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > & | __s,
|  | match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Allocator > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Determines if there is a match between the regular expression `e` and a string.

Parameters:

  | s | The string to match.
  | m | The match results.
  | re | The regular expression.
  | flags | Controls how the regular expression is matched.

Return values:

  | true | A match exists.
  | false | Otherwise.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2185 of file tr1_impl/regex.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_match().

template<typename _Ch_type , typename _Allocator , typename _Rx_traits >

bool std::regex_match | ( | const _Ch_type * | __s,
|  | match_results< const _Ch_type *, _Allocator > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Determines if there is a match between the regular expression `e` and a C-style null-terminated string.

Parameters:

  | s | The C-style null-terminated string to match.
  | m | The match results.
  | re | The regular expression.
  | f | Controls how the regular expression is matched.

Return values:

  | true | A match exists.
  | false | Otherwise.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2161 of file tr1_impl/regex.

References std::regex_match().

template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Indicates if there is a match between the regular expression `e` and all of the character sequence [first, last).

Parameters:

  | first | Beginning of the character sequence to match.
  | last | One-past-the-end of the character sequence to match.
  | re | The regular expression.
  | flags | Controls how the regular expression is matched.

Return values:

  | true | A match exists.
  | false | Otherwise.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2136 of file tr1_impl/regex.

References std::regex_match().

template<typename _Bi_iter , typename _Allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_match | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | match_results< _Bi_iter, _Allocator > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Determines if there is a match between the regular expression `e` and all of the character sequence [first, last).

Parameters:

  | first | Beginning of the character sequence to match.
  | last | One-past-the-end of the character sequence to match.
  | m | The match results.
  | re | The regular expression.
  | flags | Controls how the regular expression is matched.

Return values:

  | true | A match exists.
  | false | Otherwise.

Exceptions:

  | an | exception of type regex_error.

Todo:
  Implement this function.

Referenced by std::regex_match().

template<typename _Rx_traits , typename _Ch_type >

basic_string<_Ch_type> std::regex_replace | ( | const basic_string< _Ch_type > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Parameters:

  | s |
  | e |
  | fmt |
  | flags |

Returns:
  a copy of string `s` with replacements.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2407 of file tr1_impl/regex.

References std::back_inserter(), std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_replace().

template<typename _Out_iter , typename _Bi_iter , typename _Rx_traits , typename _Ch_type >

_Out_iter std::regex_replace | ( | _Out_iter | __out,
|  | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | const basic_string< _Ch_type > & | __fmt,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Parameters:

  | out |
  | first |
  | last |
  | e |
  | fmt |
  | flags |

Returns:
  out

Exceptions:

  | an | exception of type regex_error.

Todo:
  Implement this function.

Referenced by std::regex_replace().

template<typename _Ch_traits , typename _Ch_alloc , typename _Allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const basic_string< _Ch_type, _Ch_traits, _Ch_alloc > & | __s,
|  | match_results< typename basic_string< _Ch_type, _Ch_traits, _Ch_alloc >::const_iterator, _Allocator > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Searches for a regular expression within a string.

Parameters:

  | s | [IN] A C++ string to search for the regex.
  | m | [OUT] The set of regex matches.
  | e | [IN] The regex to search for in `s`.
  | f | [IN] The search flags.

Return values:

  | true | A match was found within the string.
  | false | No match was found within the string, the content of m is undefined.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2362 of file tr1_impl/regex.

References std::basic_string< _CharT, _Traits, _Alloc >::begin(), std::basic_string< _CharT, _Traits, _Alloc >::end(), and std::regex_search().

template<typename _Ch_traits , typename _String_allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const basic_string< _Ch_type, _Ch_traits, _String_allocator > & | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Searches for a regular expression within a string.

Parameters:

  | s | [IN] The string to search.
  | e | [IN] The regular expression to search for.
  | flags | [IN] Search policy flags.

Return values:

  | true | A match was found within the string.
  | false | No match was found within the string.

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2339 of file tr1_impl/regex.

References std::regex_search().

template<typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | const _Ch_type * | __s,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Searches for a regular expression within a C-string.

Parameters:

  | s | [IN] The C-string to search.
  | e | [IN] The regular expression to search for.
  | f | [IN] Search policy flags.

Return values:

  | true | A match was found within the string.
  | false | No match was found within the string.

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2319 of file tr1_impl/regex.

References std::regex_search().

template<typename _Ch_type , class _Allocator , class _Rx_traits >

bool std::regex_search | ( | const _Ch_type * | __s,
|  | match_results< const _Ch_type *, _Allocator > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __e,
|  | regex_constants::match_flag_type | __f = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Searches for a regular expression within a C-string.

Parameters:

  | s | [IN] A C-string to search for the regex.
  | m | [OUT] The set of regex matches.
  | e | [IN] The regex to search for in `s`.
  | f | [IN] The search flags.

Return values:

  | true | A match was found within the string.
  | false | No match was found within the string, the content of m is undefined.

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2299 of file tr1_impl/regex.

References std::regex_search().

template<typename _Bi_iter , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Searches for a regular expression within a range.

Parameters:

  | first | [IN] The start of the string to search.
  | last | [IN] One-past-the-end of the string to search.
  | re | [IN] The regular expression to search for.
  | flags | [IN] Search policy flags.

Return values:

  | true | A match was found within the string.
  | false | No match was found within the string.

Todo:
  Doc me! See doc/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Exceptions:

  | an | exception of type regex_error.

Definition at line 2275 of file tr1_impl/regex.

References std::regex_search().

template<typename _Bi_iter , typename _Allocator , typename _Ch_type , typename _Rx_traits >

bool std::regex_search | ( | _Bi_iter | __first,
|  | _Bi_iter | __last,
|  | match_results< _Bi_iter, _Allocator > & | __m,
|  | const basic_regex< _Ch_type, _Rx_traits > & | __re,
|  | regex_constants::match_flag_type | __flags = `regex_constants::match_default` |
| ) |  |  | `[inline]`

Searches for a regular expression within a range.

Parameters:

  | first | [IN] The start of the string to search.
  | last | [IN] One-past-the-end of the string to search.
  | m | [OUT] The match results.
  | re | [IN] The regular expression to search for.
  | flags | [IN] Search policy flags.

Return values:

  | true | A match was found within the string.
  | false | No match was found within the string, the content of m is undefined.

Exceptions:

  | an | exception of type regex_error.

Todo:
  Implement this function.

Referenced by std::regex_search().

template<typename _Bi_iter , typename _Allocator >

void std::swap | ( | match_results< _Bi_iter, _Allocator > & | __lhs,
|  | match_results< _Bi_iter, _Allocator > & | __rhs |
| ) |  |  | `[inline]`

Swaps two match results.

Parameters:

  | lhs | A match result.
  | rhs | A match result.

The contents of the two match_results objects are swapped.

Definition at line 2084 of file tr1_impl/regex.

References std::match_results< _Bi_iter, _Allocator >::swap().

template<typename _Ch_type , typename _Rx_traits >

void std::swap | ( | basic_regex< _Ch_type, _Rx_traits > & | __lhs,
|  | basic_regex< _Ch_type, _Rx_traits > & | __rhs |
| ) |  |  | `[inline]`

Swaps the contents of two regular expression objects.

Parameters:

  | lhs | First regular expression.
  | rhs | Second regular expression.

Definition at line 1067 of file tr1_impl/regex.

References std::basic_regex< _Ch_type, _Rx_traits >::swap().

template<typename _Ch_type >

int std::regex_traits< _Ch_type >::value | ( | _Ch_type | __ch,
|  | int | __radix |
| ) |  |  | const`[inline, inherited]`

Converts a digit to an int.

Parameters:

  | ch | a character representing a digit.
  | radix | the radix if the numeric conversion (limited to 8, 10, or 16).

Returns:
  the value represented by the digit ch in base radix if the character ch is a valid digit in base radix; otherwise returns -1.

Definition at line 688 of file tr1_impl/regex.

References std::hex(), and std::oct().